/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package lab17;

import java.io.File;
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

/**
 *
 * @author Myron Papadakis
 *
 * CS-452 Fall 2013 - Lab 17 Solution
 */
public class Lab17 {

    public static final String xmlFilePath = "lab17/books.xml";
    public static final String outputPath = "lab17/output.xml";

    public static void update() {
        try {
            DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
            Document document = documentBuilder.parse(xmlFilePath);

            //use item(0) to get the first node with tage name "book"
            Node book = document.getElementsByTagName("book").item(0);

            //update book , set the id to book101
            Element bookElem = (Element)book;
            bookElem.setAttribute("id", "bk101");
          
            // append a new node to the first book
            Element title = document.createElement("title");
            title.appendChild(document.createTextNode("XML Developer's Guide"));
            Node genre = document.getElementsByTagName("genre").item(0);

            //insert the new node before the genre element
            book.insertBefore(title, genre);

            Node priceNode = bookElem.getElementsByTagName("price").item(0);
            double price = Double.parseDouble(priceNode.getTextContent());
            priceNode.setTextContent(String.valueOf( price + 0.1 * price ) );

            Element priceElem = (Element) priceNode;
            priceElem.setAttribute("units", "USD");

            // 2nd book - description
            Element book2 = (Element) document.getElementsByTagName("book").item(1);
            Element description = (Element) book2.getElementsByTagName("description").item(0);
            book2.removeChild(description);

            // write the DOM object to the file
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();

            //indent the output
            transformer.setOutputProperty(OutputKeys.INDENT, "yes");
            transformer.setOutputProperty(OutputKeys.METHOD, "xml");
            transformer.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "3");
            DOMSource domSource = new DOMSource(document);

            StreamResult streamResult = new StreamResult(new File(outputPath));
            transformer.transform(domSource, streamResult);
            
        } catch (ParserConfigurationException pce) {
            pce.printStackTrace();
        } catch (TransformerException tfe) {
            tfe.printStackTrace();
        } catch (IOException ioe) {
            ioe.printStackTrace();
        } catch (SAXException sae) {
            sae.printStackTrace();
        }
    }
    public static void main(String argv[]) {
        update();
    }
}
